import { GQLOperationTypeEnum } from "amplify-graphql-docs-generator/lib/generator";
export declare enum Language {
    TYPESCRIPT = "typescript",
    JAVASCRIPT = "javascript"
}
export declare enum ApolloOperation {
    Query = "Query",
    LazyQuery = "LazyQuery",
    Mutation = "Mutation",
    Subscription = "Subscription"
}
export declare type OperationsForType = {
    gqlOperation: GQLOperationTypeEnum;
    apolloOperation: ApolloOperation;
    operations: {
        hookName: string;
        operationName: string;
        operationType: string;
        variablesType?: string;
    }[];
};
export declare type RenderOperationsInput = {
    operationsPerType: OperationsForType[];
    imports: Record<string, string[]>;
};
